import { useEffect, useState } from "react"
import { connect } from "react-redux"
import * as action from "../actions"


const Playerbar = ({ player, playTrack, pauseTrack, switchTrack, setTrackVolume }) => {
    let [_player, setPlayer] = useState()

    useEffect(() => {
        setPlayer(player)
    }, [player, _player])

    return (
        <footer style={{ display: `${_player?.track ? 'block' : 'none'}` }}>
            <div>
                <button
                    style={{ fontSize: '2.5vh' }}
                    onClick={() => switchTrack(false, _player?.playlistIndex, _player?.playlist)}
                >
                    {_player?.playlistIndex === 0 ? `\u23F4` : `\u23EE`}
                </button>

                {_player?.isPlaying ?
                    <button style={{ fontSize: '2.5vh' }} onClick={() => pauseTrack()}>{`\u23F8`}</button> :
                    <button style={{ fontSize: '2.5vh' }} onClick={() => playTrack()}>{`\u23F5`}</button>
                }

                <button
                    style={{ fontSize: '2.5vh' }}
                    onClick={() => switchTrack(true, _player?.playlistIndex, _player?.playlist)}
                >
                    {_player?.playlistIndex === _player?.playlist?.length - 1 ? `\u23F5` : `\u23ED`}
                </button>
                <input
                    type="range" min="0" max="1" step="any"
                    onChange={(e) => setTrackVolume(e.target.value)} />
            </div>

            {_player ? (_player.track?.id3?.artist && _player.track?.id3?.title ?
                <small>{_player.track?.id3?.artist} - {_player.track?.id3?.title}</small> :
                <small>{_player.track?.originalFileName}</small>) : ''}
            <br></br>
            <small>{_player?.playlistIndex}</small>
        </footer>
    )
}

export const PlayerbarConnect = connect(
    state => ({ player: state.player || {} }),
    {
        playTrack: action.playTrack,
        pauseTrack: action.pauseTrack,
        switchTrack: action.switchTrack,
        setTrackVolume: action.setTrackVolume
    }
)(Playerbar)